<template>
  <div class="row justify-content-md-center">
    <div class="todo-list col-6">
      <ul class="list-group mb-5 shadow">
        <li class="list-group-item d-flex justify-content-between" :class="{disabled: item.done}" v-for="(item, ind) in todoList" :key="ind">
          <span class="todo-list__item-title" :class="{complete: item.done}">{{item.title}}</span>
          <div>
            <label>
              <input type="checkbox" name="" id="" :checked="item.done" v-model="item.done">
            </label>
            <span class="todo-list__btn-destroy" @click="removeTodo(item)">
              <i class="fas fa-trash text-danger"></i>
            </span>
          </div>
        </li>
      </ul>
      <div class="input-group mb-3">
        <input v-model="newTodo" type="text" class="form-control" placeholder="todo">
        <div class="input-group-append">
          <button @click="addTodo()" class="btn btn-outline-secondary" type="button">Add</button>
        </div>
      </div>
    </div>
  </div>
</template>

<script>
  const STORAGE_KEY = todoStorage;
  let todoStorage = {
    fetch: () => {
      let todos = JSON.parse(localStorage.getItem(STORAGE_KEY) || '[]')
      todos.forEach(function (todo, index) {
        todo.id = index
      })
      return todos
    },
    save: (todos) => {
      localStorage.setItem(STORAGE_KEY, JSON.stringify(todos))
    }
  }

  export default {
    data(){
        return {
          todoList: todoStorage.fetch(),
          newTodo: ''
        }
    },
    watch: {
      todoList: {
        handler(todoList) {
          todoStorage.save(todoList)
        },
        deep: true
      }
    },
    methods: {
      addTodo() {
        if(this.newTodo.trim()){
          this.todoList.push({
            title: this.newTodo,
            done: false
          })
        } else { alert('Enter an action')}
        this.newTodo = ''
      },
      removeTodo(todo) {
        this.todoList.splice(this.todoList.indexOf(todo), 1)
      }
    }
  }
</script>

<style lang="scss" scoped>
  .todo-list{
    &__item-title{
      display: block;
      position: relative;
      &::before{
        content: '';
        display: block;
        height: 1px;
        position: absolute;
        top: 50%;
        left: 0;
        right:100%;
        background: #000;
        transition: right .4s;
      }
      &.complete{
        &::before{
          right: 0;
        }
      }
    }
    &__btn-destroy{
      cursor: pointer;
    }
  }
</style>


